models/File.php
<?php

namespace app\models;

use yii;
use yii\web\UploadedFile;
use yii\behaviors\TimestampBehavior;
use app\common\components\ActiveRecord\ActiveRecord;


/**
 * This is the model class for table "files".
 *
 * @property integer $id
 * @property string $filename
 * @property string $realPath
 * @property string $url
 * @property boolean $isLocked
 * @property integer $uploadedExpertId
 * @property integer $museumId
 * @property string $createdAt
 *
 * @property Museum $museum
 * @property User $uploadedExpert
 */
class File extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'files';
    }

	public function behaviors()
	{
		return [
			TimestampBehavior::className(),
		];
	}
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['museumId'], 'required','message'=>'Поле {attribute} необходимо для заполнения'],
            [['museumId'], 'integer','message'=>'Поле {attribute} должно быть числом'],
            [['museumId'], 'exist', 'skipOnError' => false, 'targetClass' => Museum::className(), 'targetAttribute' => ['museumId' => 'id'],'message'=>'Некорректное значение'],
	        ['url', 'url', 'defaultScheme' => 'http','message'=>'Некорректный адрес'],
	        [['filePole'], 'file', 'skipOnEmpty' => true, 'extensions' => 'docx, doc, rar, zip, pdf, xls, xlsx','wrongExtension'=>'Допустимы только файлы {extensions}'],
	        [['museumId'],'filter','filter'=>function($value){return $value==''?null:intval($value);}],
	        ['filePole', 'required','when' => function($model){
		          return is_null($model->url);
	            },
		        'whenClient' => "function (attribute, value) {
                    return false;
                }",
	            'message' => 'Файл или ссылка обязательны к заполнению.'],
	        ['filePole', 'compare','compareValue' => '', 'operator' => '=','when' => function($model){
		        return !is_null($model->url);
	        },
		        'whenClient' => "function (attribute, value) {
                    return false;
                }",
		        'message' => 'Должно быть заполнено что то одно.'],
	        ['url', 'required','when' => function($model){
		        return is_null($model->file);
	        },
		        'whenClient' => "function (attribute, value) {
                    return false;
                }",
		        'message' => 'Файл или ссылка обязательны к заполнению.'],
	        ['url', 'compare','compareValue' => '', 'operator' => '=','when' => function($model){
		        return !is_null($model->file);
	        },
		        'whenClient' => "function (attribute, value) {
                    return false;
                }",
		        'message' => 'Должно быть заполнено что то одно.'],
	        ['museumId', 'compare','compareValue' => $this->museumLastId, 'operator' => '==','when' => function($model){
			        return !is_null($model->museumLast);
		        },
		        'whenClient' => "function (attribute, value) {
                    return false;
                }",
		        'message' => 'Запрещена смена привязки музея для крайних файлов. Данный файл является крайним для ' .
			        $this->museumLastName],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'filename' => 'Файл',
            'realPath' => 'Полный путь',
            'isLocked' => 'Заблокирован',
            'uploadedExpertId' => 'Автор',
            'museumId' => 'Музей',
            'created_at' => 'Загружен',
            'updated_at' => 'Обновлен',
	        'file' => 'Файл на загрузку',
	        'url' => 'URL',
	        'filePole' => 'Файл',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMuseum()
    {
        return $this->hasOne(Museum::className(), ['id' => 'museumId']);
    }

	/**
	 * @return \yii\db\ActiveQuery
	 */
	public function getMuseumLast()
	{
		return $this->hasOne(Museum::className(), ['lastFileId' => 'id']);
	}

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUploadedExpert()
    {
        return $this->hasOne(User::className(), ['id' => 'uploadedExpertId']);
    }

	public function getUploadedExpertName()
	{
		return $this->uploadedExpert->fullname;
	}

	public function getMuseumName()
	{
		return $this->museum->name;
	}

	public function getMuseumLastId(){
		if(is_null($this->museumLast)){
			return null;
		}
		return $this->museumLast->id;
	}

	public function getMuseumLastName(){
		if(is_null($this->museumLast)){
			return null;
		}
		return $this->museumLast->name;
	}

	public function getPath( )
	{
		return Yii::getAlias('@app').'/uploads/' . $this->realPath;
	}

	public function loadMuseum(Museum $museum)
	{
		$this->museumId = $museum->id;
	}

	public function loadFiles()
	{
		$this->file = UploadedFile::getInstance($this, 'filePole');
	}

	/**
	 * @var UploadedFile
	 */
	public $filePole;
	public $file;

	public function upload()
	{
		if(is_null($this->file)){
			$this->filename = $this->url;
			$this->realPath = null;
			return true;
		}
		if ($this->validate()) {
			$this->realPath = ($this->realPath?$this->realPath:rand(1000000,9999999) . rand(1000000,9999999));
			$this->filename = $this->file->name;
			$this->file->saveAs($this->getPath());
			return true;
		} else {
			return false;
		}
	}

	public function getIsLast(){
		return !is_null($this->museumLast);
	}

	public function beforeSave($insert)
	{
		if (!parent::beforeSave($insert)) {
			return false;
		}
		$this->uploadedExpertId = Yii::$app->user->id;
		return $this->upload();
	}

	public function afterSave($insert, $changedAttributes){
		parent::afterSave($insert, $changedAttributes);
		if($insert){
			$this->museum->link('lastFile',$this);
			$this->save();
		}
	}

	public function isWithFile(){
		return $this->url!='' || !is_null($this->file);
	}
}

controllers/FileController.php
<?php

namespace app\controllers;

use yii;
use app\models\File;
use app\models\search\FileSearch;
use app\models\Museum;
use app\models\AutoStatus;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\events\FileLoadEvent;


/**
 * FileController implements the CRUD actions for File model.
 */
class FileController extends Controller
{

	const FILE_UPLOAD = 'fileUpload';
	const FILE_DOWNLOAD = 'fileDownload';
	const FILE_DEPCULT_UPLOAD = 'fileDepcultUpload';
	const FILE_DEPCULT_DOWNLOAD = 'fileDepcultDownload';

    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

	public function afterAction($action, $result)
	{
		// Проверить, что данный Action не зарегестрирован в событиях и не меняет статус
		return parent::afterAction($action, $result);
	}

	/**
     * Lists all File models.
     * @return mixed
     */
    public function actionIndex()
    {
	    if(!Yii::$app->user->can('fileIndex')){
		    return $this->redirect(['museum/index'], 302);
	    }

	    $searchModel = new FileSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
	        'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

	public function actionIndex_for_museum($id=null)
	{
		if(!Yii::$app->user->can('fileIndex')){
			return $this->redirect(['index'], 302);
		}
		if(is_null($id) || is_null($museum = Museum::findOne($id))){
			return $this->redirect(['index'], 302);
		}
		$searchModel = new FileSearch();
		$dataProvider = $searchModel->search(Yii::$app->request->queryParams, $id);

		return $this->render('index', [
			'searchModel' => $searchModel,
			'dataProvider' => $dataProvider,
		]);
	}


	/**
     * Displays a single File model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
	    if(!Yii::$app->user->can('fileView')){
		    return $this->redirect(['index'], 302);
	    }
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new File model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
	    if(!Yii::$app->user->can('fileCreate')){
		    return $this->redirect(['index'], 302);
	    }

	    $model = new File();
	    $model->loadFiles();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
	        if(Yii::$app->user->identity->group->triggered) {
	            if(Yii::$app->user->identity->group->role == 'depcult'){
                    AutoStatus::setTriggeredStatus(self::FILE_DEPCULT_UPLOAD, $model->museum);
                }
                else{
                    AutoStatus::setTriggeredStatus(self::FILE_UPLOAD, $model->museum);
                }
	        }
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

	public function actionCreate_for_museum($id=null)
	{
		$museum = Museum::findOne($id);

		if(!Yii::$app->user->can('fileCreate',['museum'=>$museum])){
			return $this->redirect(['create'], 302);
		}

		if(is_null($id) || is_null($museum)){
			return $this->redirect(['create'], 302);
		}

		$model = new File();
		$model->loadFiles();

		if ($model->load(Yii::$app->request->post()) && $model->save()) {
			if(Yii::$app->user->identity->group->triggered) {
                if(Yii::$app->user->identity->group->role == 'depcult'){
                    AutoStatus::setTriggeredStatus(self::FILE_DEPCULT_UPLOAD, $model->museum);
                }
                else{
                    AutoStatus::setTriggeredStatus(self::FILE_UPLOAD, $model->museum);
                }
			}
			return $this->redirect(['museum/index']);
		} else {
			$model->loadMuseum( $museum );
			return $this->render('create_for_museum', [
				'model' => $model,
			]);
		}
	}

    /**
     * Updates an existing File model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
	    if(!Yii::$app->user->can('fileUpdate')){
		    return $this->redirect(['index'], 302);
	    }

        $model = $this->findModel($id);
	    $model->loadFiles();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing File model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
	    if(!Yii::$app->user->can('fileDelete')){
		    return $this->redirect(['index'], 302);
	    }

        $file = $this->findModel($id);

	    if(is_null($file->museumLast))
	    {
		    $file->delete();
	    }
	    return $this->redirect(['index']);
    }

	public function actionDownload($id)
	{
		$model = $this->findModel($id);

		if(is_null($model) || !Yii::$app->user->can('fileDownload',[
				'museum'=>$model->museum,
				'file'=>$model])){
			return $this->redirect(['index'], 302);
		}

		if(Yii::$app->user->identity->group->triggered) {
            if(Yii::$app->user->identity->group->role == 'depcult'){
                AutoStatus::setTriggeredStatus(self::FILE_DEPCULT_DOWNLOAD, $model->museum);
            }
            else{
                AutoStatus::setTriggeredStatus(self::FILE_DOWNLOAD, $model->museum);
            }
		}

		Yii::$app->response->sendFile($model->path,$model->filename);
	}

    /**
     * Finds the File model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return File the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = File::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/file/_filePoles.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use app\models\Museum;

/* @var $this yii\web\View */
/* @var $model app\models\File */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="file-form">

	<?= $form->field($model, 'filePole')->fileInput() ?>

	<?= $form->field($model, 'url')->textInput() ?>

</div>

views/file/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use app\models\Museum;

/* @var $this yii\web\View */
/* @var $model app\models\File */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="file-form">

    <?php $form = ActiveForm::begin(['options' => ['enctype' => 'multipart/form-data']]); ?>

	<?= $form->field($model, 'filePole')->fileInput() ?>

	<?= $form->field($model, 'url')->textInput() ?>

	<?= $form->field($model, 'museumId')->dropDownList(ArrayHelper::getColumn( Museum::find()->indexBy('id')->all(),'name')) ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Добавить' : 'Сохранить', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/file/_form_for_museum.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use app\models\Museum;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $model app\models\File */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="file-form">

    <?php $form = ActiveForm::begin(['options' => ['enctype' => 'multipart/form-data'], 'action'=>Url::to(['file/create_for_museum','id'=>$model->museum->id])]); ?>

	<?= $form->field($model, 'filePole')->fileInput() ?>

	<?= $form->field($model, 'url')->textInput() ?>

	<?= $form->field($model, 'museumId')->hiddenInput()->label(false)?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Добавить' : 'Сохранить', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/file/_link.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $model app\models\File */
?>

<div class="file-link">

	<?=	(!is_null($model->realPath)?
		$model->filename . ' ' .
			Html::a(Html::encode('Скачать'), Url::to(['file/download', 'id' => $model->id]),['target'=>'_blank']):
		Html::a(Html::encode($model->filename), $model->url,['target'=>'_blank'])
	)?>

</div>

views/file/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\File */

$this->title = 'Добавить файл';
$this->params['breadcrumbs'][] = ['label' => 'Файлы', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="file-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/file/create_for_museum.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\File */

$this->title = 'Добавить файл для ' . $model->museum->name;
$this->params['breadcrumbs'][] = ['label' => 'Файлы', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="file-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form_for_museum', [
        'model' => $model,
    ]) ?>

</div>

views/file/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\File;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\FileSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Файлы';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="file-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Добавить файл', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
	    'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'id',
            [
                'attribute' => 'filename',
	            'format' => 'raw',
                'value' => function(File $file){
			        return $this->render('_link', [
				        'model' => $file,
			        ]);
                },
            ],
	        [
		        'attribute'=>'museumName',
		        'label'=>'Музей',
		        'format'=>'text', // Возможные варианты: raw, html
		        'value'=>'museum.name',
	        ],
	        [
		        'attribute'=>'uploadedExpertName',
		        'label'=>'Эксперт',
		        'format'=>'text', // Возможные варианты: raw, html
		        'value'=>'uploadedExpert.fullname',
	        ],
	        [
		        'attribute' => 'updated_at',
		        'format' => ['date', 'php:Y-m-d H:i:s']
	        ],
	        [
		        'attribute' => 'created_at',
		        'format' => ['date', 'php:Y-m-d H:i:s']
	        ],
            [
	            'class' => 'yii\grid\ActionColumn',
                'template' => '{view} {update}',
            ]
        ],
    ]); ?>
</div>

views/file/index_for_museum.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\File;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\FileSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
?>
<div class="file-index">
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
	    'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'id',
            [
                'attribute' => 'filename',
	            'format' => 'raw',
                'value' => function(File $file){
			        return $this->render('_link', [
				        'model' => $file,
			        ]);
                },
            ],
	        [
		        'attribute'=>'uploadedExpertName',
		        'label'=>'Эксперт',
		        'format'=>'text', // Возможные варианты: raw, html
		        'value'=>'uploadedExpert.fullname',
	        ],
        ],
    ]); ?>
</div>

views/file/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\File */

$this->title = 'Изменить файл ' . $model->filename;
$this->params['breadcrumbs'][] = ['label' => 'Файлы', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->filename, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Изменить';
?>
<div class="file-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/file/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\File;

/* @var $this yii\web\View */
/* @var $model app\models\File */

$this->title = $model->filename;
$this->params['breadcrumbs'][] = ['label' => 'Файлы', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="file-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Изменить', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?php if(!$model->isLast):?>
	        <?= Html::a('Удалить', ['delete', 'id' => $model->id], [
	            'class' => 'btn btn-danger',
	            'data' => [
	                'confirm' => 'Вы уверены, что хотите удалить файл ' . $model->filename . '?',
	                'method' => 'post',
	            ],
	        ]) ?>
	    <?php endif;?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
	        [
		        'attribute' => 'filename',
		        'format' => 'raw',
		        'value' => $this->render('_link', [
				        'model' => $model,
			        ]),
	        ],
            'uploadedExpertName',
            'museumName',
	        [
		        'attribute' => 'updated_at',
		        'format' => ['date', 'php:Y-m-d H:i:s']
	        ],
	        [
		        'attribute' => 'created_at',
		        'format' => ['date', 'php:Y-m-d H:i:s']
	        ],
        ],
    ]) ?>

</div>